# Copyright 2004 James Bunton <james@delx.cjb.net>
# Licensed for distribution under the GPL version 2, check COPYING for details

from twisted.internet.protocol import Protocol, ClientFactory
from twisted.protocols.http import HTTPClient
from twisted.internet import reactor


class ProxyFactory(ClientFactory):
	def __init__(self, server, serverport, otherfac):
		ClientFactory.__init__(self)
		self.server, self.serverport, self.otherfac = server, serverport, otherfac

	def buildProtocol(self, addr):
		p = ProxyProtocol()
		p.server, p.serverport, p.otherfac = self.server, self.serverport, self.otherfac
		return p

class ProxyProtocol(HTTPClient):
	def connectionMade(self):
		self.sendCommand("CONNECT", self.server + ":" + str(port))
	
	def handleStatus(self, version, status, message):
		if(status == "200"): # Excellent
			# Must flip over into SSL now
			pass
		else:
			# Must cancel factory
			pass

	def handleHeader(self, key, val):
		pass
	
	def handleEndHeaders(self):
		pass

def proxy_connect_ssl(proxy, proxyport, server, serverport, factory):
	pass
#	pfac = ProxyFactory(server, serverport, factory)
#	reactor.connectTCP(proxy, proxyport, pfac)


