# This file contains options to be configured by the server administrator.
# Please read through all the options in this file

# The JabberID of the transport.
jid = "msn.host.com"


# The location of the spool directory.. if relative, relative to the src dir.
# Do not include the jid of the transport.
spooldir = ".."
# The location of the PID file
pid = "../PyMSNt.pid"


# The IP address of the main Jabber server to connect to
mainServer = "127.0.0.1"
# The TCP port to connect to the Jabber server on (this is the default for Jabberd2)
port = "5347"
# The authentication token to use when connecting to the Jabber server
secret = "secret"


# The default language to use
lang = "en"


# Send email notification messages to users
mailNotifications = True # Will become a per-user option in the future
# Use fancy friendly names (based on your Jabber status message)
fancyFriendly = True # Will become a per-user option in the future
# Send greeting on login
sessionGreeting = False


# HTTPS proxy settings. To use a proxy, set both these values
# These functions are not implemented yet
proxyServer = None # proxyServer = "someserver.com"
proxyPort = None # proxyPort = 443


# Set this to True to get debugging output
debugOn = True
# Set the debug log file location here, (leave blank to output to the screen)
debugLog = "../debug.log"



